#!/usr/bin/python

import sys, getopt
import os
import fileinput
import shutil

pathAppTemplate = "C:/Program Files/DoQuBook/share/DoQuBook/templates/app"

def usage():
	print "-n AppName -t TemplateName"

def replace(inputFile, outputFile, before, after):
	inFile = open(inputFile,"r")
	outfile = file(outputFile, 'w')
	for line in inFile.readlines():
		line=line.replace(before,after)
		outfile.write(line)
				
def main(argv):                                        
		appName = ''
		templateName = ''
		try:
			opts, args = getopt.getopt(argv, "hn:t:")
			if(len(opts) == 0):
					usage()
					sys.exit(2)
			for opt, arg in opts:
					if opt in ('-n'):
						appName = arg
					elif opt in ('-t'):
							templateName = arg
		except getopt.GetoptError, err:
				print str(err)
				usage()
				sys.exit(2)

		print "Creating App : "+appName + " with template " + templateName

		os.mkdir(appName)
		os.mkdir(appName+"/src/")

		shutil.copy2(pathAppTemplate+"/"+templateName+"/Icon.icns", appName+"/Icon.icns")

		replace(pathAppTemplate+"/"+templateName+"/CMakeLists.txt", appName+"/CMakeLists.txt", "@AppName@", appName)
		replace(pathAppTemplate+"/"+templateName+"/src/main.cpp", appName+"/src/main.cpp", "@AppName@", appName)

if __name__ == "__main__":
			main(sys.argv[1:])		

