#!/usr/bin/python

import sys, getopt
import os
import fileinput
import shutil

pathPluginTemplate = "C:/Program Files/DoQuBook/share/DoQuBook/templates/plugin"

def usage():
	print "-p MyPluginName -t PluginType"

def replace(inputFile, outputFile, before, after):
	inFile = open(inputFile,"r")
	outfile = file(outputFile, 'w')
	for line in inFile.readlines():
		line=line.replace(before,after)
		outfile.write(line)
	
def main(argv):                                        
	pluginName = ''
	pluginType = ''
	try:
		opts, args = getopt.getopt(argv, "hp:t:")
		if(len(opts) == 0):
				usage()
				sys.exit(2)
		for opt, arg in opts:
			if opt in ('-p'):
				pluginName = arg
			elif opt in ('-t'):	
				pluginType = arg
	except getopt.GetoptError, err:
		# print help information and exit:
		print str(err) # will print something like "option -a not recognized"
		usage()
		sys.exit(2)
		
	print "Creating Plugin : "+pluginName + " of type " + pluginType
	
	shutil.copytree(pathPluginTemplate+"/"+pluginType+"/", pluginName)
	replace(pathPluginTemplate+"/"+pluginType+"/CMakeLists.txt", pluginName+"/CMakeLists.txt", "@PluginName@", pluginName)
	replace(pathPluginTemplate+"/"+pluginType+"/src/PluginName.hpp", pluginName+"/src/"+pluginName+".hpp", "@PluginName@", pluginName)
	replace(pathPluginTemplate+"/"+pluginType+"/src/PluginName.cpp", pluginName+"/src/"+pluginName+".cpp", "@PluginName@", pluginName)
	replace(pathPluginTemplate+"/"+pluginType+"/test/TestPluginName.hpp", pluginName+"/test/Test"+pluginName+".hpp", "@PluginName@", pluginName)
	replace(pathPluginTemplate+"/"+pluginType+"/test/TestPluginName.cpp", pluginName+"/test/Test"+pluginName+".cpp", "@PluginName@", pluginName)
	

if __name__ == "__main__":
			main(sys.argv[1:])


				

