#ifndef ANNOTATIONSERVICE_HPP
#define ANNOTATIONSERVICE_HPP


#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>

#include <DoQuBook/AnnotationLocal.hpp>
#include <DoQuBook/AnnotationGlobal.hpp>

#include <DoQuBook/CRUDService.hpp>

namespace DoQuBook
{


    class AnnotationService;
    typedef QSharedPointer<AnnotationService> AnnotationServicePtr;


    class DoQuBookSHARED_EXPORT AnnotationService : virtual public CRUDService<Annotation, int>
    {
        public:
            AnnotationService();
            virtual ~AnnotationService();

            //virtual AnnotationPtr get (const int &name) = 0;
            virtual AnnotationLocalPtr getAnnotationLocal (const int & id) = 0;
            virtual AnnotationGlobalPtr getAnnotationGlobal (const int & id) = 0;

            //virtual void add (AnnotationPtr &ann) = 0;

            //virtual void add (AnnotationLocalPtr &ann) = 0;
            //virtual void add (AnnotationGlobalPtr &ann) = 0;

            //virtual bool del (AnnotationPtr ann) = 0;
    };

}

#endif // ANNOTATIONSERVICE_HPP
