#ifndef BINARIZER_HPP
#define BINARIZER_HPP


#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/Page.hpp>
#include <DoQuBook/Region.hpp>
#include <DoQuBook/Config.hpp>

#include <DoQuBook/AlgorithmOnTask.hpp>


class DoQuBookSHARED_EXPORT Binarizer  : public DoQuBook::AlgorithmOnTask
{
    public:


        virtual ~Binarizer();

        // --- To be implemented //
        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual QImage binarize (const QImage & image, const QVariantMap & params = QVariantMap() ) = 0;
        // --- //

        virtual QList<DoQuBook::ExecutorParameterPtr> parameters () {
            QList<DoQuBook::ExecutorParameterPtr> params;
            return params;
        }

        virtual QString pluginType () {
            return "Binarizer";
        }

        virtual QString returnType() {
            return "Image";
        }

        virtual QList<DoQuBook::ExecutorParameterPtr> methodParameters() {
            QList<DoQuBook::ExecutorParameterPtr> params;
            params << DoQuBook::ExecutorParameter::create ("image", "Image", true);
            return params;
        }

        virtual QVariant compute (const QVariantMap & pluginMethodParams, const QVariantMap & params = QVariantMap() ) {
            qDebug() << "Binarizing !!! ";
            QImage image = pluginMethodParams["image"].value<QImage>();
            return binarize (image, params);
        }

};


typedef std_shared_ptr<Binarizer>::type BinarizerPtr;

#define Binarizer_iid "fr.labri.doqubook.Binarizer"

Q_DECLARE_INTERFACE (Binarizer, Binarizer_iid)

#endif // BINARIZER_HPP
