#ifndef BOOKSERVICE_HPP
#define BOOKSERVICE_HPP

#include <QSharedPointer>
#include <DoQuBook/Book.hpp>


namespace DoQuBook
{

    class BookService;
    typedef QSharedPointer<BookService> BookServicePtr;

    class BookService :  public QObject
    {
            Q_OBJECT
        public:
            BookService();

            virtual QList<int> getAllBooks () = 0;

            virtual BookPtr get (const int & id) = 0;
            virtual void del (const int & name) = 0;
            virtual void del (BookPtr book) = 0;
            virtual void update (BookPtr book) = 0;
            virtual bool put (BookPtr b) = 0;

    };

}

#endif // BOOKSERVICE_HPP
