/*!
 * \brief This file is part of DoQuBook Framework
 *
 * Main author :  Rabeux Vincent <rabeux@labri.fr>
 * from LaBRI, University of Bordeaux 1 - Sud Ouest
 *
 * \details DoQuBook is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * \version RC-0.0.2
 * \date    2011
 *
 * Authors and main contributors :
 * \author Rabeux Vincent <rabeux@labri.fr>
 * \author Maxime Daymard <mr.xyz@hotmail.fr>
 * \author Jean-Philippe Domenger <domenger@labri.fr>
 * \author Nicholas Journet <journet@labri.fr>
 *
 * \copyright GNU LGPL.
 * Copyright (C) 2003-2011 <LaBRI>. All Rights Reserved.
 * Web: <www.labri.fr>
 *
 * DoQuBook is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 * WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */
#ifndef BOOLEAN_HPP
#define BOOLEAN_HPP

#include <QObject>
#include <DoQuBook/SimpleMarshallable.hpp>
#include <QSharedPointer>

namespace DoQuBook
{


    class Boolean;
    typedef QSharedPointer<Boolean> BooleanPtr;

    class DoQuBookSHARED_EXPORT Boolean : public SimpleMarshallable
    {
            Q_OBJECT
            Q_PROPERTY (bool value READ getValue WRITE setValue)
        public:
            MARSHALLABLE_CREATE_FONCTIONS (Boolean)

            bool getValue() const;

        public slots:
            void setValue (bool arg);

        private :
            Boolean();

            bool m_value;
    };

}

#endif // BOOLEAN_HPP
