#ifndef DBWEBBINARIZERREMOTEPROXY_HPP
#define DBWEBBINARIZERREMOTEPROXY_HPP

#include <DoQuBook/Binarizer.hpp>
#include <DoQuBook/Repository.hpp>
#include <DoQuBook/RemotePluginFactory.hpp>


class DBWebBinarizerRemoteProxy : public Binarizer
{
        Q_OBJECT
    public :
        class BinarizerRemotePluginFactory : public DoQuBook::RemotePluginFactory
        {
            public :
                BinarizerRemotePluginFactory()
                {}

                virtual bool accepts (DoQuBook::RepositoryPtr repo, DoQuBook::ExecutorPtr exec)  {
                    m_repo = repo;
                    m_exec = exec;
                    return  exec->getPluginType() == "Binarizer";
                }

                virtual QObject * build();
                virtual void unLoad();
                virtual RemotePluginFactory * clone();
        };

    public:
        DBWebBinarizerRemoteProxy (DoQuBook::RepositoryPtr repo,
                                   DoQuBook::ExecutorPtr executor);

        virtual QString organisationName () ;
        virtual QString description () ;
        virtual QString algorithmName ();
        virtual QString version();
        virtual QString pluginType () ;


        virtual QImage binarize (const QImage & image, const QVariantMap & params = QVariantMap() );

    private :
        DoQuBook::RepositoryPtr _repo;
        DoQuBook::ExecutorPtr _executor;

};

#endif // DBWEBBINARIZERREMOTEPROXY_HPP
