#ifndef DBWEBEXECUTORSERVICE_HPP
#define DBWEBEXECUTORSERVICE_HPP


#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/ExecutorService.hpp>
#include <DoQuBook/RESTObjectManager.hpp>
#include <DoQuBook/StringList.hpp>
#include <DoQuBook/DaemonService.hpp>

namespace DoQuBook
{

    class DoQuBookSHARED_EXPORT DBWebExecutorService : public ExecutorService
    {
        public:
            DBWebExecutorService (const QString & serverAdress);

            virtual void add (ExecutorPtr & executor) ;
            virtual ExecutorPtr get (const QString & id) ;
            virtual QList<QString> getAll ();
            virtual bool del (ExecutorPtr & executor) ;
            virtual void update (ExecutorPtr & executor);

        private :
            QString m_serverAdress;
            RESTObjectManager<Executor> m_executorManager;
            RESTObjectManager<StringList> m_idsManager;
            QString m_restServicesUrl;
    };

}
#endif // DBWEBEXECUTORSERVICE_HPP
