#ifndef DBWEBGROUNDTRUTHSERVICE_HPP
#define DBWEBGROUNDTRUTHSERVICE_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/RESTImageManager.hpp>
#include <DoQuBook/RESTObjectManager.hpp>
#include <DoQuBook/DBWebPageService.hpp>

#include <DoQuBook/Intlist.hpp>

#include <DoQuBook/GroundTruthService.hpp>

namespace  DoQuBook
{

    class DBWebGroundTruthService ;
    typedef QSharedPointer<DBWebGroundTruthService> DBWebGroundTruthServicePtr;


    class DoQuBookSHARED_EXPORT DBWebGroundTruthService : public QObject, public GroundTruthService
    {
            Q_OBJECT

        public:

            DBWebGroundTruthService (const QString & serverAdress);
            virtual ~DBWebGroundTruthService();


            virtual meta_iterator<PagePtr>::IteratorPtr getAllBinarisationGTedPages();
            virtual void addBinarisationGroundTruth (const PagePtr page, const QFileInfo & file);
            virtual QImage getBinarisationGroundTruth (const PagePtr page);

            virtual void onBinarizationGroundTruthAdded (Functor<Page> *functor);


        private :
            QString m_server_adress;

            RESTImageManager m_binImageManager;
            RESTObjectManager<PageRestIterator> m_getAllByChunksManager;
    };

}

#endif // DBWEBGROUNDTRUTHSERVICE_HPP
