#ifndef DBWEBIMAGESERVICE_HPP
#define DBWEBIMAGESERVICE_HPP


#include <DoQuBook/ImageService.hpp>

namespace DoQuBook
{

    class DBWebImageService;
    typedef QSharedPointer<DBWebImageService> DBWebImageServicePtr;

    class DBWebImageService : public ImageService
    {
        public:
            DBWebImageService (const QString & server_url);
            virtual ~DBWebImageService() {}

            virtual QImage get (const PagePtr & page,  int w = -1);
            virtual void upload (const QImage & image, const PagePtr & page) ;

        protected :
            virtual QImage getImageOnRemoteServer (const PagePtr & page, int w);

        private :
            QString m_serverAdress;
            QString rest_service_url;
            QString book_ressource;
            QString image_ressource;

            RESTImageManager m_pageImageManager;
    };
}

#endif // DBWEBIMAGESERVICE_HPP
