#ifndef DTW_HPP
#define DTW_HPP

#include <QList>
#include <QVector>
#include <QHash>
#include <QImage>

class Dtw
{
    public:
        Dtw();

        class DTWResult
        {
            public:
                float distance;
                QVector<QVector<int> > D;
        };

        struct BinMatch {
            int templ_x;
            int obs_x;
        };

        class BinMatchList
        {
            public:
                BinMatchList ();
                QList<BinMatch> getAll (int templ_x);
                void add (int templ_x, int obs_x);
                void toQDebug();
                QList<BinMatch> getBestPath();
            private :
                QList<BinMatch> bestPath;
        };

        DTWResult classify (const QList<size_t> &templ, const QList<size_t> &observation);

        BinMatchList getBestPath ();

        QImage toImage (QVector<size_t> hProfile1, int thd1,
                        QVector<size_t> hProfile2, int thd2,
                        QImage & img);

        inline void init_int_array (int * a, int num_rows, int num_cols, int val) {
            int i;

            for ( i = 0; i < num_rows * num_cols; i++) {
                * (a + i) = val;
            }
        }

        DTWResult m_lastResult;
        qint16 m_N;
        qint16 m_M;
};



#endif // DTW_HPP
