#ifndef GROUNDTRUTHSERVICE_HPP
#define GROUNDTRUTHSERVICE_HPP

#include <QSharedPointer>
#include <DoQuBook/Page.hpp>
#include <DoQuBook/CRUDService.hpp>
#include <QFileInfo>
#include <DoQuBook/ListRestFileAttachment.hpp>
#include <DoQuBook/Future.hpp>

namespace DoQuBook
{

    class GroundTruthService;
    typedef QSharedPointer<GroundTruthService> GroundTruthServicePtr;


    class GroundTruthService
    {
        public:
            virtual ~GroundTruthService () {}

            /** Binarisation **/
            virtual meta_iterator<PagePtr>::IteratorPtr getAllBinarisationGTedPages() = 0;
            virtual void addBinarisationGroundTruth (const PagePtr page, const QFileInfo & file) = 0;
            virtual QImage getBinarisationGroundTruth (const PagePtr page) = 0;

            virtual void onBinarizationGroundTruthAdded (Functor<Page> *functor) = 0;

    };

}
#endif // GROUNDTRUTHSERVICE_HPP
