#ifndef HISTOGRAM_HPP
#define HISTOGRAM_HPP

#include <DoQuBook/SimpleMarshallable.hpp>
#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>

namespace DoQuBook
{

    class Histogram;
    typedef QSharedPointer<Histogram> HistogramPtr;

    class DoQuBookSHARED_EXPORT Histogram : public SimpleMarshallable
    {

            Q_OBJECT
            Q_PROPERTY (QList<double> histoValues READ getValues WRITE setValues)

        public:
            MARSHALLABLE_CREATE_FONCTIONS (Histogram)

            MARSHALLABLE_QTLIST (QList, double, histoValues)
            MARSHALLABLE_ACTIV_1LIST (histoValues, _values)

            Histogram();

            QList<double>  getValues();
            void  setValues (QList<double> pvalues);

        private :
            QList<double> _values;

    };

}

Q_DECLARE_METATYPE ( DoQuBook::HistogramPtr )
#endif // HISTOGRAM_HPP
