#ifndef PAGEFILTER_HPP
#define PAGEFILTER_HPP

#include <DoQuBook/Page.hpp>
#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/AlgorithmOnTask.hpp>

class DoQuBookSHARED_EXPORT ImageFilter : public DoQuBook::AlgorithmOnTask
{
    public:
        ImageFilter();
        virtual ~ImageFilter();

        // --- To be implemented //
        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual QImage filter (const QImage & image, const QVariantMap & params = QVariantMap() ) = 0;
        // --- //


        virtual QList<DoQuBook::ExecutorParameterPtr> parameters () {
            QList<DoQuBook::ExecutorParameterPtr> params;
            return params;
        }

        virtual QString pluginType () {
            return "ImageFilter";
        }

        virtual QString returnType() {
            return "Image";
        }

        virtual QList<DoQuBook::ExecutorParameterPtr> methodParameters() {
            QList<DoQuBook::ExecutorParameterPtr> params;
            params << DoQuBook::ExecutorParameter::create ("image", "Image", true);
            return params;
        }

        virtual QVariant compute (const QVariantMap & pluginMethodParams, const QVariantMap & params = QVariantMap() ) {
            QImage image = pluginMethodParams["image"].value<QImage>();
            return filter (image, params);
        }

};


typedef std_shared_ptr<ImageFilter>::type ImageFilterPtr;

#define ImageFilter_iid "fr.labri.doqubook.ImageFilter"

Q_DECLARE_INTERFACE (ImageFilter, ImageFilter_iid)

#endif // PAGEFILTER_HPP
