#ifndef IMAGESERVICE_HPP
#define IMAGESERVICE_HPP

#include <QImage>
#include <QString>
#include <DoQuBook/Page.hpp>
#include <DoQuBook/RESTImageManager.hpp>

namespace DoQuBook
{


    class ImageService;
    typedef QSharedPointer<ImageService> ImageServicePtr;

    class ImageService
    {
        public:
            ImageService();
            virtual ~ImageService() {}

            virtual QImage get (const PagePtr & page, int w = -1) = 0;

            virtual void upload (const QImage & image, const PagePtr & page) = 0;
    };

}

#endif // IMAGESERVICE_HPP
