#ifndef OCR_HPP
#define OCR_HPP

#include <QVariant>
#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/AlgorithmOnTask.hpp>

class DoQuBookSHARED_EXPORT OCR : public DoQuBook::AlgorithmOnTask
{
    public:
        OCR () {}
        virtual ~OCR () {}

        // --- To be implemented //
        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual QString ocr (const QImage & image, const QVariantMap & params = QVariantMap() ) = 0;
        // --- //

        virtual QList<DoQuBook::ExecutorParameterPtr> parameters () {
            QList<DoQuBook::ExecutorParameterPtr> params;
            return params;
        }

        virtual QString pluginType () {
            return "OCR";
        }

        virtual QString returnType() {
            return "String";
        }

        virtual QList<DoQuBook::ExecutorParameterPtr> methodParameters() {
            QList<DoQuBook::ExecutorParameterPtr> params;
            params << DoQuBook::ExecutorParameter::create ("image", "Image", true);
            return params;
        }

        virtual QVariant compute (const QVariantMap & pluginMethodParams, const QVariantMap & params = QVariantMap() ) {
            qDebug() << "OCRinzing !!! ";
            QImage image = pluginMethodParams["image"].value<QImage>();
            return ocr (image, params);
        }

};

typedef std_shared_ptr<OCR>::type OCRPtr;
#define OCR_iid "fr.labri.doqubook.OCR"
Q_DECLARE_INTERFACE (OCR, OCR_iid)

#endif // RECTOVERSOREGISTRATION_HPP
