#ifndef PAGEATTACHMENTPROVIDER_HPP
#define PAGEATTACHMENTPROVIDER_HPP

#include <QObject>
#include <QCache>
#include <QImage>
#include <QSharedPointer>
#include <QVariant>
#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/Book.hpp>
#include <DoQuBook/Page.hpp>
#include <DoQuBook/Exceptions.hpp>

namespace DoQuBook
{

    class DoQuBookSHARED_EXPORT PageAttachmentProvider : public QObject
    {
            Q_OBJECT
        public:
            static const int CACHE_SIZE = 10;
            explicit PageAttachmentProvider (QObject * parent = 0);
            virtual ~PageAttachmentProvider();

            void setBook (BookPtr book);
            QImage getImage (PagePtr page,  QString imageName);


            virtual void setParam (QVariant v) {
                param = v;
            }

            /**
              * creates a new instance of the PageImageProvider.
              */
            //virtual PageAttachmentProvider * clone() = 0;

        signals:

        public slots:

        protected :
            virtual QImage * get (PagePtr page,  QString imageName) = 0;

        protected:
            QCache<QString, QImage> imagesCache;
            BookPtr _book;
            QVariant param;
    };

}

#endif // PAGEATTACHMENTPROVIDER_HPP
