#ifndef PAGECOLLECTIONSERVICE_HPP
#define PAGECOLLECTIONSERVICE_HPP

#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/Page.hpp>
#include <DoQuBook/RESTObjectManager.hpp>
#include <DoQuBook/Intlist.hpp>
#include <DoQuBook/StringList.hpp>
#include <DoQuBook/DBWebPageService.hpp>

namespace DoQuBook
{

    class PageService;

    class PageCollectionService;
    typedef QSharedPointer<PageCollectionService> PageCollectionServicePtr;



    /// \todo This is WRONG ! PageCOllection must be an abstract interface
    class DoQuBookSHARED_EXPORT PageCollectionService : public QObject
    {
            Q_OBJECT
        public:
            PageCollectionService (const QString & serverAdress);

            void addPage (const QString & collectionName, PagePtr & page);
            Q_INVOKABLE QList<int> getPagesIds (const QString & collectionName);
            QList<QString> getAll ();

            Q_INVOKABLE meta_iterator<PagePtr>::IteratorPtr getPages (const QString & collectionName);

        private :
            QString m_serverAdress;
            RESTObjectManager<Page> m_collectionPageManager;
            RESTObjectManager<PageRestIterator> m_pageListManager;
            RESTObjectManager<Intlist> m_pageIdsManager;
            RESTObjectManager<StringList> m_idsManager;
            PageService * m_pageService;
    };


    class OnQListPageIterator;
    typedef QSharedPointer<OnQListPageIterator> OnQListPageIteratorPtr;

    class DoQuBookSHARED_EXPORT OnQListPageIterator : public QObject, public Iterator<PagePtr>
    {
            Q_OBJECT
        public :
            OnQListPageIterator (QList<PagePtr> &pages) : _pages (pages), _deleg (_pages) {}
            virtual ~OnQListPageIterator () {}
            virtual bool hasNext() {
                return _deleg.hasNext();
            }

            virtual PagePtr next() {
                return _deleg.next();
            }

        private :
            QList<PagePtr> _pages;
            QListIterator<PagePtr> _deleg;
    };


    class DoQuBookSHARED_EXPORT PageRandomSplitedSets : public QObject
    {
            Q_OBJECT
        public :
            PageRandomSplitedSets (meta_iterator<PagePtr>::IteratorPtr it, int percentInFirstSet);
            ~PageRandomSplitedSets();

            meta_iterator<PagePtr>::IteratorPtr firstSetIterator() {
                return firstSetIt;
            }

            meta_iterator<PagePtr>::IteratorPtr secondSetIterator() {
                return secondSetIt;
            }

        private :
            meta_iterator<PagePtr>::IteratorPtr firstSetIt;
            meta_iterator<PagePtr>::IteratorPtr secondSetIt;
    };

}

#endif // PAGECOLLECTIONSERVICE_HPP
