#ifndef BINARIZER_HPP
#define BINARIZER_HPP

#include <DoQuBook/Page.hpp>
#include <DoQuBook/DoQuBook_global.hpp>
#include <DoQuBook/Region.hpp>
#include <DoQuBook/Config.hpp>

#include <DoQuBook/AlgorithmOnTask.hpp>

class PageCreator  : public DoQuBook::AlgorithmOnTask
{
    public:

        PageCreator()
        {}

        virtual ~PageCreator() {}

        // --- To be implemented //
        virtual QString organisationName () = 0;
        virtual QString description () = 0;
        virtual QString algorithmName () = 0;
        virtual QString version() = 0;
        virtual DoQuBook::PagePtr create (const QVariantMap & params = QVariantMap() ) = 0;
        // --- //

        virtual QList<DoQuBook::ExecutorParameterPtr> parameters () {
            QList<DoQuBook::ExecutorParameterPtr> params;
            return params;
        }


        virtual QString returnType() {
            return "Page";
        }

        virtual QList<DoQuBook::ExecutorParameterPtr> methodParameters() {
            QList<DoQuBook::ExecutorParameterPtr> params;
            return params;
        }

        virtual QVariant compute (const QVariantMap & pluginMethodParams, const QVariantMap & params = QVariantMap() ) {
            qDebug() << "Creating a Page !!! ";
            DoQuBook::PagePtr page = create (pluginMethodParams);
            qRegisterMetaType<DoQuBook::PagePtr> ("Page");
            int pageId = QMetaType::type ("Page");


            QVariant v (pageId, &page);

            return v;
        }

};

typedef QSharedPointer<PageCreator> PageCreatorPtr;

Q_DECLARE_INTERFACE (PageCreator, "doqubook.pagecreator")

#endif // BINARIZER_HPP
