#ifndef PAGEEVENT_HPP
#define PAGEEVENT_HPP

#include <QObject>
#include <DoQuBook/SimpleMarshallable.hpp>
#include <DoQuBook/Future.hpp>
#include <DoQuBook/Page.hpp>

namespace DoQuBook {



class PageEvent : public QObject , public Functor<Page> {

    Q_OBJECT

public :
    PageEvent (QObject *parent);
    virtual void process(DoQuBook::PagePtr object) {
        postUnMarshall(object);
        emit processSignal(object);
    }

protected :
    virtual void postUnMarshall(const PagePtr &/*object*/) {}

signals :
    void processSignal(DoQuBook::PagePtr page);
};


class DBWebPageEvent : public PageEvent {

public :
    DBWebPageEvent (const QString &serveradress, const QString subscriptionUrl, QObject *parent = NULL);
    virtual void postUnMarshall(const DoQuBook::PagePtr &object);

    void addFunctor(Functor<Page> *f);

private :
    QString _serveradress;
    HttpEventHandler<Page> _eventHandler;
};

}

#endif // PAGEEVENT_HPP
