#ifndef PIXELFEATURECOMPUTER_HPP
#define PIXELFEATURECOMPUTER_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <DoQuBook/PixelFeatures.hpp>
#include <DoQuBook/PluginBase.hpp>
#include <QList>



class DoQuBookSHARED_EXPORT PixelFeaturesComputer : public PluginBase
{
  public:
    PixelFeaturesComputer( ) {}
    virtual ~PixelFeaturesComputer(){}


    virtual DoQuBook::PixelFeaturesListPtr extract (const QImage &image, const QVariantMap & parameters = QVariantMap() ) = 0;

    // From PluginBase
    virtual QString pluginType () {return "PixelFeaturesComputer";}
    virtual QString returnType() {return "PixelFeaturesList";}
};

typedef std::tr1::shared_ptr<PixelFeaturesComputer> PixelFeaturesComputerPtr;

#define PixelFeaturesComputer_iid "fr.labri.doqubook.PixelFeaturesComputer"

Q_DECLARE_INTERFACE (PixelFeaturesComputer, PixelFeaturesComputer_iid)

#endif // PIXELFEATURECOMPUTER_HPP
