#ifndef RESTIMAGEMANAGER_HPP
#define RESTIMAGEMANAGER_HPP

#include <DoQuBook/DoQuBook_global.hpp>
#include <QUrl>
#include <DoQuBook/WebClient.hpp>
#include <QDebug>
#include <QImage>

namespace DoQuBook
{

    class DoQuBookSHARED_EXPORT RESTImageManager
    {
        public:
            enum ImageType {
                JPEG,
                PNG,
                TIFF
            };

            RESTImageManager (ImageType type);

            void addRessourcePath (WebClient::Method method, const QString & string);

            QImage get (const QMap<QString, QString> &params);
            QByteArray post (const QImage & image, const QString & fileName, ImageType type = PNG);
            QByteArray post (const QImage & image, const QString & fileName, const QMap<QString, QString> &params, ImageType type = PNG);

        private :
            QUrl urlFromParams (const QMap<QString, QString> &params, WebClient::Method method);
            void setContentTypeOnWebClient (WebClient & client);

        private :
            ImageType m_imageType;
            QMap<WebClient::Method, QString> m_routPaths;
    };

}
#endif // RESTIMAGEMANAGER_HPP
