#ifndef STRINGLIST_HPP
#define STRINGLIST_HPP

#include <DoQuBook/SimpleMarshallable.hpp>
#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>

namespace DoQuBook
{
    class StringList;
    typedef QSharedPointer<StringList> StringListPtr;


    class DoQuBookSHARED_EXPORT StringList : public SimpleMarshallable
    {
            Q_OBJECT
            Q_PROPERTY (QList<QString> strings READ getStrings WRITE setStrings)
        public:

            MARSHALLABLE_CREATE_FONCTIONS (StringList)

            MARSHALLABLE_QTLIST (QList, QString, strings)
            MARSHALLABLE_ACTIV_1LIST (strings, _strings)

            StringList();

            QList<QString>  getStrings ();
            void  setStrings (const QList<QString> &pStrings);

        private :
            QList<QString> _strings;
    };

}

#endif // STRINGLIST_HPP
