#ifndef TASKSERVICE_HPP
#define TASKSERVICE_HPP

#include <DoQuBook/DoQuBook_global.hpp>

#include <QSharedPointer>
#include <DoQuBook/Task.hpp>
#include <DoQuBook/Page.hpp>

namespace DoQuBook
{

    class TaskService;
    typedef QSharedPointer<TaskService> TaskServicePtr;



    class DoQuBookSHARED_EXPORT TaskService
    {
        public:
            TaskService() {}
            virtual ~TaskService() {}

            virtual TaskPtr get (int id) = 0;
            virtual TaskPtr getTaskWhenDone (int id) = 0;
            virtual QList<int> getAll () = 0;
            virtual QList<int> getNewTasks () = 0;
            virtual QList<int> getNewTasksForExecutors (QStringList & executors) = 0;
            virtual void add (TaskPtr & task) = 0;
            virtual bool del (TaskPtr & task) = 0;

            virtual void notifyAccepted (TaskPtr & task) = 0;
            virtual void notifyHasFailed (TaskPtr & task) = 0;
            virtual void setFinalResult (TaskPtr & task) = 0;
            virtual void refreshForm (TaskPtr & task) = 0;


            virtual void runExecutor (const QString & name,
                                      PagePtr & page,
                                      const QVariantMap & paramsMap = QVariantMap()
                                     ) = 0;

            /// Should not be used directly
            virtual void convertTaskParametersToQVariant (TaskPtr task) = 0;
    };

}

#endif // TASKSERVICE_HPP
